// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: vcs_provider.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	VCSProviders_GetVCSProviderByID_FullMethodName         = "/martiancloud.phobos.api.vcsprovider.VCSProviders/GetVCSProviderByID"
	VCSProviders_GetVCSProviders_FullMethodName            = "/martiancloud.phobos.api.vcsprovider.VCSProviders/GetVCSProviders"
	VCSProviders_GetRepositoryArchive_FullMethodName       = "/martiancloud.phobos.api.vcsprovider.VCSProviders/GetRepositoryArchive"
	VCSProviders_CreateVCSProvider_FullMethodName          = "/martiancloud.phobos.api.vcsprovider.VCSProviders/CreateVCSProvider"
	VCSProviders_UpdateVCSProvider_FullMethodName          = "/martiancloud.phobos.api.vcsprovider.VCSProviders/UpdateVCSProvider"
	VCSProviders_DeleteVCSProvider_FullMethodName          = "/martiancloud.phobos.api.vcsprovider.VCSProviders/DeleteVCSProvider"
	VCSProviders_ResetVCSProviderOAuthToken_FullMethodName = "/martiancloud.phobos.api.vcsprovider.VCSProviders/ResetVCSProviderOAuthToken"
	VCSProviders_CreateVCSTokenForPipeline_FullMethodName  = "/martiancloud.phobos.api.vcsprovider.VCSProviders/CreateVCSTokenForPipeline"
)

// VCSProvidersClient is the client API for VCSProviders service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// VCSProviders implements all functionality related to Version Control System
// Providers.
type VCSProvidersClient interface {
	// GetVCSProviderByID returns a VCSProvider by its ID.
	GetVCSProviderByID(ctx context.Context, in *GetVCSProviderByIDRequest, opts ...grpc.CallOption) (*VCSProvider, error)
	// GetVCSProviders returns a paginated list of VCSProviders.
	GetVCSProviders(ctx context.Context, in *GetVCSProvidersRequest, opts ...grpc.CallOption) (*GetVCSProvidersResponse, error)
	// GetRepositoryArchive returns the archive for a given repository.
	GetRepositoryArchive(ctx context.Context, in *GetRepositoryArchiveRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetRepositoryArchiveResponse], error)
	// CreateVCSProvider creates a new VCSProvider.
	CreateVCSProvider(ctx context.Context, in *CreateVCSProviderRequest, opts ...grpc.CallOption) (*CreateVCSProviderResponse, error)
	// UpdateVCSProvider updates a existing VCSProvider.
	UpdateVCSProvider(ctx context.Context, in *UpdateVCSProviderRequest, opts ...grpc.CallOption) (*VCSProvider, error)
	// DeleteVCSProvider deletes a VCSProvider.
	DeleteVCSProvider(ctx context.Context, in *DeleteVCSProviderRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// ResetVCSProviderOAuthToken resets the OAuth token used to authenticate with
	// the remote VCS system.
	ResetVCSProviderOAuthToken(ctx context.Context, in *ResetVCSProviderOAuthTokenRequest, opts ...grpc.CallOption) (*ResetVCSProviderOAuthTokenResponse, error)
	// CreateVCSTokenForPipeline creates a new VCS token for a pipeline.
	CreateVCSTokenForPipeline(ctx context.Context, in *CreateVCSTokenForPipelineRequest, opts ...grpc.CallOption) (*CreateVCSTokenForPipelineResponse, error)
}

type vCSProvidersClient struct {
	cc grpc.ClientConnInterface
}

func NewVCSProvidersClient(cc grpc.ClientConnInterface) VCSProvidersClient {
	return &vCSProvidersClient{cc}
}

func (c *vCSProvidersClient) GetVCSProviderByID(ctx context.Context, in *GetVCSProviderByIDRequest, opts ...grpc.CallOption) (*VCSProvider, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(VCSProvider)
	err := c.cc.Invoke(ctx, VCSProviders_GetVCSProviderByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vCSProvidersClient) GetVCSProviders(ctx context.Context, in *GetVCSProvidersRequest, opts ...grpc.CallOption) (*GetVCSProvidersResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetVCSProvidersResponse)
	err := c.cc.Invoke(ctx, VCSProviders_GetVCSProviders_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vCSProvidersClient) GetRepositoryArchive(ctx context.Context, in *GetRepositoryArchiveRequest, opts ...grpc.CallOption) (grpc.ServerStreamingClient[GetRepositoryArchiveResponse], error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	stream, err := c.cc.NewStream(ctx, &VCSProviders_ServiceDesc.Streams[0], VCSProviders_GetRepositoryArchive_FullMethodName, cOpts...)
	if err != nil {
		return nil, err
	}
	x := &grpc.GenericClientStream[GetRepositoryArchiveRequest, GetRepositoryArchiveResponse]{ClientStream: stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type VCSProviders_GetRepositoryArchiveClient = grpc.ServerStreamingClient[GetRepositoryArchiveResponse]

func (c *vCSProvidersClient) CreateVCSProvider(ctx context.Context, in *CreateVCSProviderRequest, opts ...grpc.CallOption) (*CreateVCSProviderResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(CreateVCSProviderResponse)
	err := c.cc.Invoke(ctx, VCSProviders_CreateVCSProvider_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vCSProvidersClient) UpdateVCSProvider(ctx context.Context, in *UpdateVCSProviderRequest, opts ...grpc.CallOption) (*VCSProvider, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(VCSProvider)
	err := c.cc.Invoke(ctx, VCSProviders_UpdateVCSProvider_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vCSProvidersClient) DeleteVCSProvider(ctx context.Context, in *DeleteVCSProviderRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, VCSProviders_DeleteVCSProvider_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vCSProvidersClient) ResetVCSProviderOAuthToken(ctx context.Context, in *ResetVCSProviderOAuthTokenRequest, opts ...grpc.CallOption) (*ResetVCSProviderOAuthTokenResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(ResetVCSProviderOAuthTokenResponse)
	err := c.cc.Invoke(ctx, VCSProviders_ResetVCSProviderOAuthToken_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vCSProvidersClient) CreateVCSTokenForPipeline(ctx context.Context, in *CreateVCSTokenForPipelineRequest, opts ...grpc.CallOption) (*CreateVCSTokenForPipelineResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(CreateVCSTokenForPipelineResponse)
	err := c.cc.Invoke(ctx, VCSProviders_CreateVCSTokenForPipeline_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// VCSProvidersServer is the server API for VCSProviders service.
// All implementations must embed UnimplementedVCSProvidersServer
// for forward compatibility.
//
// VCSProviders implements all functionality related to Version Control System
// Providers.
type VCSProvidersServer interface {
	// GetVCSProviderByID returns a VCSProvider by its ID.
	GetVCSProviderByID(context.Context, *GetVCSProviderByIDRequest) (*VCSProvider, error)
	// GetVCSProviders returns a paginated list of VCSProviders.
	GetVCSProviders(context.Context, *GetVCSProvidersRequest) (*GetVCSProvidersResponse, error)
	// GetRepositoryArchive returns the archive for a given repository.
	GetRepositoryArchive(*GetRepositoryArchiveRequest, grpc.ServerStreamingServer[GetRepositoryArchiveResponse]) error
	// CreateVCSProvider creates a new VCSProvider.
	CreateVCSProvider(context.Context, *CreateVCSProviderRequest) (*CreateVCSProviderResponse, error)
	// UpdateVCSProvider updates a existing VCSProvider.
	UpdateVCSProvider(context.Context, *UpdateVCSProviderRequest) (*VCSProvider, error)
	// DeleteVCSProvider deletes a VCSProvider.
	DeleteVCSProvider(context.Context, *DeleteVCSProviderRequest) (*emptypb.Empty, error)
	// ResetVCSProviderOAuthToken resets the OAuth token used to authenticate with
	// the remote VCS system.
	ResetVCSProviderOAuthToken(context.Context, *ResetVCSProviderOAuthTokenRequest) (*ResetVCSProviderOAuthTokenResponse, error)
	// CreateVCSTokenForPipeline creates a new VCS token for a pipeline.
	CreateVCSTokenForPipeline(context.Context, *CreateVCSTokenForPipelineRequest) (*CreateVCSTokenForPipelineResponse, error)
	mustEmbedUnimplementedVCSProvidersServer()
}

// UnimplementedVCSProvidersServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedVCSProvidersServer struct{}

func (UnimplementedVCSProvidersServer) GetVCSProviderByID(context.Context, *GetVCSProviderByIDRequest) (*VCSProvider, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetVCSProviderByID not implemented")
}
func (UnimplementedVCSProvidersServer) GetVCSProviders(context.Context, *GetVCSProvidersRequest) (*GetVCSProvidersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetVCSProviders not implemented")
}
func (UnimplementedVCSProvidersServer) GetRepositoryArchive(*GetRepositoryArchiveRequest, grpc.ServerStreamingServer[GetRepositoryArchiveResponse]) error {
	return status.Errorf(codes.Unimplemented, "method GetRepositoryArchive not implemented")
}
func (UnimplementedVCSProvidersServer) CreateVCSProvider(context.Context, *CreateVCSProviderRequest) (*CreateVCSProviderResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateVCSProvider not implemented")
}
func (UnimplementedVCSProvidersServer) UpdateVCSProvider(context.Context, *UpdateVCSProviderRequest) (*VCSProvider, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateVCSProvider not implemented")
}
func (UnimplementedVCSProvidersServer) DeleteVCSProvider(context.Context, *DeleteVCSProviderRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteVCSProvider not implemented")
}
func (UnimplementedVCSProvidersServer) ResetVCSProviderOAuthToken(context.Context, *ResetVCSProviderOAuthTokenRequest) (*ResetVCSProviderOAuthTokenResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ResetVCSProviderOAuthToken not implemented")
}
func (UnimplementedVCSProvidersServer) CreateVCSTokenForPipeline(context.Context, *CreateVCSTokenForPipelineRequest) (*CreateVCSTokenForPipelineResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateVCSTokenForPipeline not implemented")
}
func (UnimplementedVCSProvidersServer) mustEmbedUnimplementedVCSProvidersServer() {}
func (UnimplementedVCSProvidersServer) testEmbeddedByValue()                      {}

// UnsafeVCSProvidersServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to VCSProvidersServer will
// result in compilation errors.
type UnsafeVCSProvidersServer interface {
	mustEmbedUnimplementedVCSProvidersServer()
}

func RegisterVCSProvidersServer(s grpc.ServiceRegistrar, srv VCSProvidersServer) {
	// If the following call pancis, it indicates UnimplementedVCSProvidersServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&VCSProviders_ServiceDesc, srv)
}

func _VCSProviders_GetVCSProviderByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVCSProviderByIDRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VCSProvidersServer).GetVCSProviderByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VCSProviders_GetVCSProviderByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VCSProvidersServer).GetVCSProviderByID(ctx, req.(*GetVCSProviderByIDRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VCSProviders_GetVCSProviders_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVCSProvidersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VCSProvidersServer).GetVCSProviders(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VCSProviders_GetVCSProviders_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VCSProvidersServer).GetVCSProviders(ctx, req.(*GetVCSProvidersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VCSProviders_GetRepositoryArchive_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(GetRepositoryArchiveRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(VCSProvidersServer).GetRepositoryArchive(m, &grpc.GenericServerStream[GetRepositoryArchiveRequest, GetRepositoryArchiveResponse]{ServerStream: stream})
}

// This type alias is provided for backwards compatibility with existing code that references the prior non-generic stream type by name.
type VCSProviders_GetRepositoryArchiveServer = grpc.ServerStreamingServer[GetRepositoryArchiveResponse]

func _VCSProviders_CreateVCSProvider_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateVCSProviderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VCSProvidersServer).CreateVCSProvider(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VCSProviders_CreateVCSProvider_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VCSProvidersServer).CreateVCSProvider(ctx, req.(*CreateVCSProviderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VCSProviders_UpdateVCSProvider_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateVCSProviderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VCSProvidersServer).UpdateVCSProvider(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VCSProviders_UpdateVCSProvider_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VCSProvidersServer).UpdateVCSProvider(ctx, req.(*UpdateVCSProviderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VCSProviders_DeleteVCSProvider_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteVCSProviderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VCSProvidersServer).DeleteVCSProvider(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VCSProviders_DeleteVCSProvider_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VCSProvidersServer).DeleteVCSProvider(ctx, req.(*DeleteVCSProviderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VCSProviders_ResetVCSProviderOAuthToken_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ResetVCSProviderOAuthTokenRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VCSProvidersServer).ResetVCSProviderOAuthToken(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VCSProviders_ResetVCSProviderOAuthToken_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VCSProvidersServer).ResetVCSProviderOAuthToken(ctx, req.(*ResetVCSProviderOAuthTokenRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VCSProviders_CreateVCSTokenForPipeline_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateVCSTokenForPipelineRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VCSProvidersServer).CreateVCSTokenForPipeline(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VCSProviders_CreateVCSTokenForPipeline_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VCSProvidersServer).CreateVCSTokenForPipeline(ctx, req.(*CreateVCSTokenForPipelineRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// VCSProviders_ServiceDesc is the grpc.ServiceDesc for VCSProviders service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var VCSProviders_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.vcsprovider.VCSProviders",
	HandlerType: (*VCSProvidersServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetVCSProviderByID",
			Handler:    _VCSProviders_GetVCSProviderByID_Handler,
		},
		{
			MethodName: "GetVCSProviders",
			Handler:    _VCSProviders_GetVCSProviders_Handler,
		},
		{
			MethodName: "CreateVCSProvider",
			Handler:    _VCSProviders_CreateVCSProvider_Handler,
		},
		{
			MethodName: "UpdateVCSProvider",
			Handler:    _VCSProviders_UpdateVCSProvider_Handler,
		},
		{
			MethodName: "DeleteVCSProvider",
			Handler:    _VCSProviders_DeleteVCSProvider_Handler,
		},
		{
			MethodName: "ResetVCSProviderOAuthToken",
			Handler:    _VCSProviders_ResetVCSProviderOAuthToken_Handler,
		},
		{
			MethodName: "CreateVCSTokenForPipeline",
			Handler:    _VCSProviders_CreateVCSTokenForPipeline_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetRepositoryArchive",
			Handler:       _VCSProviders_GetRepositoryArchive_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "vcs_provider.proto",
}
